## API Report File for "@edtr-io/core"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { Action } from '@edtr-io/store';
import { ChangeListener } from '@edtr-io/store';
import { CustomTheme } from '@edtr-io/ui';
import { EditorPlugin } from '@edtr-io/internal__plugin';
import { GlobalHotKeys } from 'react-hotkeys';
import { HotKeys } from 'react-hotkeys';
import { IgnoreKeys } from 'react-hotkeys';
import * as InternalDocumentEditor from '@edtr-io/internal__document-editor/beta';
import * as InternalPluginToolbar from '@edtr-io/internal__plugin-toolbar/beta';
import { PluginProps } from '@edtr-io/internal__plugin-state';
import { ProviderProps } from 'react-redux';
import * as React_2 from 'react';
import { ScopedState } from '@edtr-io/store';
import { State } from '@edtr-io/store';
import { Store } from '@edtr-io/store';
import { StoreEnhancerFactory } from '@edtr-io/store';
import { Unsubscribe } from 'redux';

// @beta
function Document_2<K extends string = string>(props: Omit<EditorProps<K>, 'initialState'> & {
    scope: string;
} & ({
    mirror: true;
    initialState?: unknown;
} | {
    mirror?: false;
    initialState: EditorProps<K>['initialState'];
})): JSX.Element | null;

export { Document_2 as Document }

// @public (undocumented)
export const DocumentEditorContext: React_2.Context<React_2.ComponentType<InternalDocumentEditor.DocumentEditorProps>>;

// @public
export function Editor<K extends string = string>(props: EditorProps<K>): JSX.Element;

// @public (undocumented)
export interface EditorProps<K extends string = string> {
    // (undocumented)
    children?: React_2.ReactNode | ((document: React_2.ReactNode) => React_2.ReactNode);
    // (undocumented)
    createStoreEnhancer?: StoreEnhancerFactory;
    // (undocumented)
    DocumentEditor?: React_2.ContextType<typeof DocumentEditorContext>;
    // (undocumented)
    editable?: boolean;
    // (undocumented)
    initialState: {
        plugin: string;
        state?: unknown;
    };
    // (undocumented)
    omitDragDropContext?: boolean;
    // (undocumented)
    onChange?: ChangeListener;
    // (undocumented)
    onError?: React_2.ContextType<typeof ErrorContext>;
    // (undocumented)
    plugins: Record<K, EditorPlugin>;
    // (undocumented)
    PluginToolbar?: React_2.ContextType<typeof PluginToolbarContext>;
    // (undocumented)
    theme?: CustomTheme;
}

// @beta
export function EditorProvider(props: EditorProviderProps): JSX.Element;

// @public (undocumented)
export interface EditorProviderProps {
    // (undocumented)
    children: React_2.ReactNode;
    // (undocumented)
    createStoreEnhancer?: StoreEnhancerFactory;
    // (undocumented)
    omitDragDropContext?: boolean;
}

// @public (undocumented)
export const ErrorContext: React_2.Context<((error: Error, errorInfo: {
    componentStack: string;
}) => void) | undefined>;

export { GlobalHotKeys }

export { HotKeys }

export { IgnoreKeys }

// @public
export function OverlayButton(props: OverlayButtonProps): JSX.Element;

// @public (undocumented)
export type OverlayButtonProps = InternalPluginToolbar.OverlayButtonProps;

// @public
export function OverlayCheckbox(props: OverlayCheckboxProps): JSX.Element;

// @public (undocumented)
export type OverlayCheckboxProps = InternalPluginToolbar.OverlayCheckboxProps;

// @public
export function OverlayInput(props: OverlayInputProps): JSX.Element;

// @public (undocumented)
export type OverlayInputProps = InternalPluginToolbar.OverlayInputProps;

// @public
export function OverlaySelect(props: OverlaySelectProps): JSX.Element;

// @public (undocumented)
export type OverlaySelectProps = InternalPluginToolbar.OverlaySelectProps;

// @public
export function OverlayTextarea(props: OverlayTextareaProps): JSX.Element;

// @public (undocumented)
export type OverlayTextareaProps = InternalPluginToolbar.OverlayTextareaProps;

// @public
export const PluginToolbarButton: React_2.ForwardRefExoticComponent<Pick<InternalPluginToolbar.PluginToolbarButtonProps, "className" | "icon" | "label" | "onClick"> & React_2.RefAttributes<HTMLButtonElement>>;

// @public (undocumented)
export type PluginToolbarButtonProps = InternalPluginToolbar.PluginToolbarButtonProps;

// @public (undocumented)
export const PluginToolbarContext: React_2.Context<InternalPluginToolbar.PluginToolbar>;

// @public
export function PluginToolbarOverlayButton(props: PluginToolbarOverlayButtonProps): JSX.Element;

// @public (undocumented)
export type PluginToolbarOverlayButtonProps = InternalPluginToolbar.PluginToolbarOverlayButtonProps;

// @beta (undocumented)
export interface Preference {
    // (undocumented)
    getKey: (key: string) => unknown;
    // (undocumented)
    setKey: (key: string, val: unknown) => void;
}

// @beta (undocumented)
export const PreferenceContext: React_2.Context<Preference>;

// @public
export function Provider(props: ProviderProps<Action> & {
    children: React_2.ReactNode;
}): JSX.Element;

// @public (undocumented)
export const ScopeContext: React_2.Context<{
    scope: string;
    editable?: boolean | undefined;
}>;

// @beta
export function setDefaultPreference(key: string, val: unknown): void;

// @public
export const SubDocument: (props: SubDocumentProps) => JSX.Element;

// @public (undocumented)
export interface SubDocumentProps {
    // (undocumented)
    id: string;
    // (undocumented)
    pluginProps?: PluginProps;
}

// @public (undocumented)
export const useDispatch: () => (action: Action) => void;

// @public (undocumented)
export function useScope(enforcedScope?: string): string;

// @public
export function useScopedDispatch(enforcedScope?: string): (scopedAction: (scope: string) => Action) => void;

// @public
export function useScopedSelector<T>(scopedSelector: (state: ScopedState) => T, enforcedScope?: string): T;

// @public
export function useScopedStore(enforcedScope?: string): {
    dispatch: (scopedAction: (scope: string) => Action) => void;
    getState: () => ScopedState;
    subscribe: (listener: () => void) => Unsubscribe;
};

// @public (undocumented)
export const useSelector: <T>(selector: (state: State) => T) => T;

// @public (undocumented)
export const useStore: () => Store;


// (No @packageDocumentation comment for this package)

```
