## API Report File for "@edtr-io/internal__plugin-state"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import * as InternalDocumentEditor from '@edtr-io/internal__document-editor/beta';

// @public
export interface FocusableChild {
    id: string;
}

// @public (undocumented)
export interface PluginProps {
    // (undocumented)
    config?: {};
    // (undocumented)
    renderSettings?: InternalDocumentEditor.DocumentEditorProps['renderSettings'];
    // (undocumented)
    renderToolbar?: InternalDocumentEditor.DocumentEditorProps['renderToolbar'];
}

// @public
export type StateExecutor<T> = (resolve: (value: T) => void, reject: (value: T) => void, next: (value: T) => void) => void;

// @public
export interface StateType<S = any, T = any, R = any> {
    createInitialState(helpers: StoreDeserializeHelpers): T;
    deserialize(serialized: S, helpers: StoreDeserializeHelpers): T;
    getFocusableChildren(state: T): FocusableChild[];
    init(state: T, onChange: (initial: StateUpdater<T>, executor?: StateExecutor<StateUpdater<T>>) => void): R;
    serialize(deserialized: T, helpers: StoreSerializeHelpers): S;
}

// @public
export type StateTypeReturnType<D extends StateType> = D extends StateType<any, any, infer R> ? R : never;

// @public
export type StateTypeSerializedType<D extends StateType> = D extends StateType<infer S> ? S : never;

// @public (undocumented)
export type StateTypesReturnType<Ds extends Record<string, StateType>> = {
    [K in keyof Ds]: StateTypeReturnType<Ds[K]>;
};

// @public (undocumented)
export type StateTypesSerializedType<Ds extends Record<string, StateType>> = {
    [K in keyof Ds]: StateTypeSerializedType<Ds[K]>;
};

// @public (undocumented)
export type StateTypesValueType<Ds extends Record<string, StateType>> = {
    [K in keyof Ds]: StateTypeValueType<Ds[K]>;
};

// @public
export type StateTypeValueType<D extends StateType> = D extends StateType<any, infer T> ? T : never;

// @public
export type StateUpdater<T> = (previousState: T, helpers: StoreDeserializeHelpers) => T;

// @public
export interface StoreDeserializeHelpers<K extends string = string, S = unknown> {
    createDocument(document: {
        id: string;
        plugin: K;
        state?: S;
    }): void;
}

// @public
export interface StoreSerializeHelpers<K extends string = string, S = unknown> {
    getDocument(id: string): {
        plugin: K;
        state?: S;
    } | null;
}


// (No @packageDocumentation comment for this package)

```
