## API Report File for "@edtr-io/store"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { EditorPlugin } from '@edtr-io/internal__plugin';
import { StateExecutor } from '@edtr-io/internal__plugin-state';
import { StateType } from '@edtr-io/internal__plugin-state';
import { StateUpdater } from '@edtr-io/internal__plugin-state';
import { Store as Store_2 } from 'redux';
import { StoreEnhancer } from 'redux';

// @public (undocumented)
export type Action = ClipboardAction | DocumentsAction | FocusAction | HistoryAction | PluginAction | RootAction | SetPartialState;

// @public (undocumented)
export type ActionCreator<T = string, P = any> = ActionCreatorWithoutPayload<T> | ActionCreatorWithPayload<T, P>;

// @public (undocumented)
export type ActionCreatorAction<T extends ActionCreator> = ReturnType<ReturnType<T>>;

// @public (undocumented)
export interface ActionCreatorWithoutPayload<T = string> {
    // (undocumented)
    (): (scope: string) => {
        type: T;
        scope: string;
    };
    // (undocumented)
    type: T;
}

// @public (undocumented)
export interface ActionCreatorWithPayload<T = string, P = any> {
    // (undocumented)
    (payload: P): (scope: string) => {
        type: T;
        payload: P;
        scope: string;
    };
    // (undocumented)
    type: T;
}

// @internal (undocumented)
export const applyActions: ActionCreatorWithPayload<'ApplyActions', InternalAction[]>;

// @internal (undocumented)
export interface ApplyActionsAction {
    // (undocumented)
    payload: InternalAction[];
    // (undocumented)
    scope: string;
    // (undocumented)
    type: 'ApplyActions';
}

// @public (undocumented)
const blur_2: ActionCreatorWithoutPayload<'Blur'>;

export { blur_2 as blur }

// @public (undocumented)
export type BlurAction = ActionCreatorAction<typeof blur_2>;

// @public (undocumented)
export const change: ActionCreatorWithPayload<'Change', {
    id: string;
    state: {
        initial: StateUpdater<unknown>;
        executor?: StateExecutor<StateUpdater<unknown>>;
    };
}>;

// @public (undocumented)
export type ChangeAction = ActionCreatorAction<typeof change>;

// @public (undocumented)
export type ChangeListener = (payload: {
    changed: boolean;
    getDocument: () => SelectorReturnType<typeof serializeRootDocument>;
}) => void;

// @public (undocumented)
export type ClipboardAction = CopyAction;

// @internal (undocumented)
export const clipboardReducer: SubReducer<DocumentState[]>;

// @internal (undocumented)
export const commit: ActionCreatorWithPayload<'Commit', ReversibleAction[]>;

// @internal (undocumented)
export interface CommitAction {
    // (undocumented)
    payload: ReversibleAction[];
    // (undocumented)
    scope: string;
    // (undocumented)
    type: 'Commit';
}

// @beta (undocumented)
export const copy: ActionCreatorWithPayload<'Copy', string | null>;

// @public (undocumented)
export interface CopyAction {
    // (undocumented)
    payload: string | null;
    // (undocumented)
    scope: string;
    // (undocumented)
    type: 'Copy';
}

// @public
export function createStore<K extends string>(options: StoreOptions<K>): {
    store: Store_2<State, Action>;
};

// @public (undocumented)
export type DocumentsAction = InsertAction | RemoveAction | ChangeAction | WrapAction | UnwrapAction | ReplaceAction;

// @internal (undocumented)
export const documentsReducer: SubReducer<Record<string, DocumentState>>;

// @public (undocumented)
export interface DocumentState {
    // (undocumented)
    plugin: string;
    // (undocumented)
    state: unknown;
}

// @public
export function findNextNode(root: Node_2, from: string): string | null;

// @public
export function findParent(root: Node_2, id: string): Node_2 | null;

// @public
export function findPreviousNode(root: Node_2, from: string): string | null;

// @public (undocumented)
const focus_2: ActionCreatorWithPayload<'Focus', string>;

export { focus_2 as focus }

// @public (undocumented)
export type FocusAction = BlurAction | FocusDocumentAction | FocusNextDocumentAction | FocusPreviousDocumentAction;

// @public (undocumented)
export type FocusDocumentAction = ActionCreatorAction<typeof focus_2>;

// @public (undocumented)
export const focusNext: ActionCreatorWithoutPayload<'FocusNext'>;

// @public (undocumented)
export type FocusNextDocumentAction = ActionCreatorAction<typeof focusNext>;

// @public (undocumented)
export const focusPrevious: ActionCreatorWithoutPayload<'FocusPrevious'>;

// @public (undocumented)
export type FocusPreviousDocumentAction = ActionCreatorAction<typeof focusPrevious>;

// @internal (undocumented)
export const focusReducer: SubReducer<string | null>;

// @beta (undocumented)
export const getClipboard: Selector<DocumentState[]>;

// @public (undocumented)
export const getDocument: Selector<DocumentState | null, [string | null]>;

// @public (undocumented)
export const getDocuments: Selector<Record<string, DocumentState>>;

// @public
export const getFocused: Selector<string | null, []>;

// @public
export const getFocusPath: Selector<string[] | null, [string?]>;

// @public
export const getFocusTree: Selector<Node_2 | null, [string?]>;

// @internal (undocumented)
export const getHistory: InternalSelector<HistoryState>;

// @public (undocumented)
export const getParent: Selector<Node_2 | null, [string]>;

// @public (undocumented)
export const getPendingChanges: Selector<number>;

// @public (undocumented)
export const getPlugin: Selector<EditorPlugin<StateType<any, any, any>, {}> | null, [string]>;

// @public (undocumented)
export const getPlugins: Selector<Record<string, EditorPlugin<StateType>>>;

// @internal (undocumented)
export const getRedoStack: InternalSelector<ReversibleAction[][]>;

// @public (undocumented)
export const getRoot: Selector<string | null>;

// @public
export function getScope(state: State, scope: string): ScopedState;

// @internal (undocumented)
export const getUndoStack: InternalSelector<ReversibleAction[][]>;

// @public
export const hasFocusedChild: Selector<boolean, [string]>;

// @public
export const hasFocusedDescendant: Selector<boolean, [string]>;

// @public (undocumented)
export const hasPendingChanges: Selector<boolean>;

// @public (undocumented)
export type HistoryAction = PersistAction | ResetAction | UndoAction | RedoAction;

// @internal (undocumented)
export const historyReducer: SubReducer<HistoryState>;

// @internal (undocumented)
export interface HistoryState {
    // (undocumented)
    initialState?: {
        documents: ScopedState['documents'];
    };
    // (undocumented)
    pendingChanges: number;
    // (undocumented)
    redoStack: ReversibleAction[][];
    // (undocumented)
    undoStack: ReversibleAction[][];
}

// @public (undocumented)
export const initRoot: ActionCreatorWithPayload<'InitRoot', {
    initialState: {
        plugin: string;
        state?: unknown;
    };
    plugins: Record<string, EditorPlugin>;
}>;

// @public (undocumented)
export type InitRootAction = ActionCreatorAction<typeof initRoot>;

// @public (undocumented)
export const insert: ActionCreatorWithPayload<"Insert", {
    id: string;
    plugin: string;
    state?: unknown;
}>;

// @public (undocumented)
export type InsertAction = ActionCreatorAction<typeof insert>;

// @public (undocumented)
export const insertChildAfter: ActionCreatorWithPayload<'InsertChildAfter', {
    parent: string;
    sibling?: string;
    document?: {
        plugin: string;
        state?: unknown;
    };
}>;

// @public (undocumented)
export type InsertChildAfterAction = ActionCreatorAction<typeof insertChildAfter>;

// @public (undocumented)
export const insertChildBefore: ActionCreatorWithPayload<"InsertChildBefore", {
    parent: string;
    sibling: string;
    document?: {
        plugin: string;
        state?: unknown;
    } | undefined;
}>;

// @public (undocumented)
export type InsertChildBeforeAction = ActionCreatorAction<typeof insertChildBefore>;

// @internal (undocumented)
export type InternalAction = Action | ApplyActionsAction | InternalClipboardAction | InternalDocumentsAction | InternalHistoryAction | InternalRootAction;

// @internal (undocumented)
export type InternalClipboardAction = PureCopyAction;

// @internal (undocumented)
export type InternalDocumentsAction = PureInsertAction | PureRemoveAction | PureChangeAction | PureWrapAction | PureUnwrapAction | PureReplaceAction;

// @internal (undocumented)
export type InternalHistoryAction = PureResetAction | CommitAction | PureCommitAction | PureUndoAction | PureRedoAction | TemporaryCommitAction;

// @internal (undocumented)
export type InternalRootAction = PureInitRootAction;

// @internal (undocumented)
export interface InternalScopedState extends ScopedState {
    // (undocumented)
    history: HistoryState;
}

// @internal (undocumented)
export type InternalSelector<T = any, P extends any[] = []> = (...args: P) => (scopedState: InternalScopedState) => T;

// @internal (undocumented)
export type InternalSelectorReturnType<T extends InternalSelector<any, any>> = ReturnType<ReturnType<T>>;

// @internal (undocumented)
export type InternalState = Record<string, InternalScopedState>;

// @internal (undocumented)
export type InternalStore = Store_2<InternalState, InternalAction>;

// @public
export function isDocumentEmpty(doc: DocumentState | null, plugin: EditorPlugin | null): boolean;

// @public (undocumented)
export const isEmpty: Selector<boolean, [string]>;

// @public
export const isFocused: Selector<boolean, [string]>;

// @public (undocumented)
export const mayInsertChild: Selector<boolean, [string]>;

// @public (undocumented)
export const mayRemoveChild: Selector<boolean, [string]>;

// @public (undocumented)
interface Node_2 {
    // (undocumented)
    children?: Node_2[];
    // (undocumented)
    id: string;
}

export { Node_2 as Node }

// @public (undocumented)
export const persist: ActionCreatorWithoutPayload<"Persist">;

// @public (undocumented)
export type PersistAction = ActionCreatorAction<typeof persist>;

// @public (undocumented)
export type PluginAction = InsertChildBeforeAction | InsertChildAfterAction | RemoveChildAction;

// @internal (undocumented)
export const pluginsReducer: SubReducer<Record<string, EditorPlugin>>;

// @internal (undocumented)
export const pureChange: ActionCreatorWithPayload<'PureChange', {
    id: string;
    state: unknown;
}>;

// @internal (undocumented)
export type PureChangeAction = ActionCreatorAction<typeof pureChange>;

// @internal (undocumented)
export const pureCommit: ActionCreatorWithPayload<'PureCommit', {
    combine: boolean;
    actions: ReversibleAction[];
}>;

// @internal (undocumented)
export interface PureCommitAction {
    // (undocumented)
    payload: {
        combine: boolean;
        actions: ReversibleAction[];
    };
    // (undocumented)
    scope: string;
    // (undocumented)
    type: 'PureCommit';
}

// @internal (undocumented)
export const pureCopy: ActionCreatorWithPayload<'PureCopy', DocumentState>;

// @internal (undocumented)
export type PureCopyAction = ActionCreatorAction<typeof pureCopy>;

// @internal (undocumented)
export const pureInitRoot: ActionCreatorWithoutPayload<'PureInitRoot'>;

// @internal (undocumented)
export type PureInitRootAction = ActionCreatorAction<typeof pureInitRoot>;

// @internal (undocumented)
export const pureInsert: ActionCreatorWithPayload<"PureInsert", {
    id: string;
} & DocumentState>;

// @internal (undocumented)
export type PureInsertAction = ActionCreatorAction<typeof pureInsert>;

// @internal (undocumented)
export const pureRedo: ActionCreatorWithoutPayload<'PureRedo'>;

// @internal (undocumented)
export type PureRedoAction = ActionCreatorAction<typeof pureRedo>;

// @internal (undocumented)
export const pureRemove: ActionCreatorWithPayload<"PureRemove", string>;

// @internal (undocumented)
export type PureRemoveAction = ActionCreatorAction<typeof pureRemove>;

// @internal (undocumented)
export const pureReplace: ActionCreatorWithPayload<'PureReplace', {
    id: string;
    plugin: string;
    state?: unknown;
}>;

// @internal (undocumented)
export type PureReplaceAction = ActionCreatorAction<typeof pureReplace>;

// @internal (undocumented)
export const pureReset: ActionCreatorWithoutPayload<"PureReset">;

// @internal (undocumented)
export type PureResetAction = ActionCreatorAction<typeof pureReset>;

// @internal (undocumented)
export const pureUndo: ActionCreatorWithoutPayload<'PureUndo'>;

// @internal (undocumented)
export type PureUndoAction = ActionCreatorAction<typeof pureUndo>;

// @internal (undocumented)
export const pureUnwrap: ActionCreatorWithPayload<'PureUnwrap', {
    id: string;
    oldId: string;
}>;

// @internal (undocumented)
export type PureUnwrapAction = ActionCreatorAction<typeof pureUnwrap>;

// @internal (undocumented)
export const pureWrap: ActionCreatorWithPayload<'PureWrap', {
    id: string;
    newId: string;
    document: DocumentState;
}>;

// @internal (undocumented)
export type PureWrapAction = ActionCreatorAction<typeof pureWrap>;

// @public (undocumented)
export const redo: ActionCreatorWithoutPayload<'Redo'>;

// @public (undocumented)
export type RedoAction = ActionCreatorAction<typeof redo>;

// @public (undocumented)
export const remove: ActionCreatorWithPayload<"Remove", string>;

// @public (undocumented)
export type RemoveAction = ActionCreatorAction<typeof remove>;

// @public (undocumented)
export const removeChild: ActionCreatorWithPayload<'RemoveChild', {
    parent: string;
    child: string;
}>;

// @public (undocumented)
export type RemoveChildAction = ActionCreatorAction<typeof removeChild>;

// @public (undocumented)
export const replace: ActionCreatorWithPayload<'Replace', {
    id: string;
    plugin: string;
    state?: unknown;
}>;

// @public (undocumented)
export type ReplaceAction = ActionCreatorAction<typeof replace>;

// @public (undocumented)
export const reset: ActionCreatorWithoutPayload<"Reset">;

// @public (undocumented)
export type ResetAction = ActionCreatorAction<typeof reset>;

// @internal (undocumented)
export interface ReversibleAction<A extends InternalAction = InternalAction, R extends InternalAction = InternalAction> {
    // (undocumented)
    action: A;
    // (undocumented)
    reverse: R;
}

// @public (undocumented)
export type RootAction = InitRootAction;

// @internal (undocumented)
export const rootReducer: SubReducer<string | null>;

// @public (undocumented)
export interface ScopedState {
    // (undocumented)
    clipboard: DocumentState[];
    // (undocumented)
    documents: Record<string, DocumentState>;
    // (undocumented)
    focus: string | null;
    // (undocumented)
    history: unknown;
    // (undocumented)
    plugins: Record<string, EditorPlugin>;
    // (undocumented)
    root: string | null;
}

// @public (undocumented)
export type Selector<T = any, P extends any[] = []> = (...args: P) => (scopedState: ScopedState) => T;

// @public (undocumented)
export type SelectorReturnType<T extends Selector<any, any>> = ReturnType<ReturnType<T>>;

// @public
export const serializeDocument: Selector<{
    plugin: string;
    state: any;
} | null, [string | null]>;

// @public (undocumented)
export const serializeRootDocument: Selector<{
    plugin: string;
    state: any;
} | null>;

// @public (undocumented)
export type SetPartialState = ActionCreatorAction<typeof setPartialState>;

// @public (undocumented)
export const setPartialState: ActionCreatorWithPayload<"SetPartialState", Partial<ScopedState>>;

// @public (undocumented)
export type State = Record<string, ScopedState>;

// @public (undocumented)
export type Store = Store_2<State, Action>;

// @public (undocumented)
export type StoreEnhancerFactory = (defaultEnhancer: StoreEnhancer) => StoreEnhancer;

// @public (undocumented)
export interface StoreOptions<K extends string> {
    // (undocumented)
    createEnhancer: StoreEnhancerFactory;
    // (undocumented)
    scopes: Record<string, Record<K, EditorPlugin>>;
}

// @internal (undocumented)
export type SubReducer<S = unknown> = (action: InternalAction, state: InternalScopedState | undefined) => S;

// @internal (undocumented)
export const temporaryCommit: ActionCreatorWithPayload<'TemporaryCommit', {
    initial: ReversibleAction[];
    executor?: StateExecutor<ReversibleAction[]>;
}>;

// @internal (undocumented)
export interface TemporaryCommitAction {
    // (undocumented)
    payload: {
        initial: ReversibleAction[];
        executor?: StateExecutor<ReversibleAction[]>;
    };
    // (undocumented)
    scope: string;
    // (undocumented)
    type: 'TemporaryCommit';
}

// @public (undocumented)
export const undo: ActionCreatorWithoutPayload<'Undo'>;

// @public (undocumented)
export type UndoAction = ActionCreatorAction<typeof undo>;

// @public (undocumented)
export const unwrap: ActionCreatorWithPayload<'Unwrap', {
    id: string;
    oldId: string;
}>;

// @public (undocumented)
export type UnwrapAction = ActionCreatorAction<typeof unwrap>;

// @public (undocumented)
export const wrap: ActionCreatorWithPayload<'Wrap', {
    id: string;
    document: (id: string) => DocumentState;
}>;

// @public (undocumented)
export type WrapAction = ActionCreatorAction<typeof wrap>;


// (No @packageDocumentation comment for this package)

```
